﻿using System;
using System.Data.SqlClient;
using System.Windows.Forms;

namespace ProgramacaoAssincrona
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCarregar_Click(object sender, EventArgs e)
        {
            CarregaDados();
        }
        private void CarregaDados()
        {
            SqlConnection conn = new SqlConnection(@"Data Source=.\sqlexpress;Initial Catalog=Cadastro;Integrated Security=True");
            string sql = @"select Id,Nome from Alunos";
            try{
                SqlCommand cmd = new SqlCommand(sql,conn);
                conn.Open();
                SqlDataReader rdr = cmd.ExecuteReader();
                while (rdr.Read()){
                    txtDados.AppendText("\nId: ");
                    txtDados.AppendText(rdr.GetValue(0) + "\t\t" + rdr.GetValue(1));
                    txtDados.AppendText("\n");
                }
            }
            catch (SqlException ex){
                MessageBox.Show(ex.Message + ex.StackTrace, "Detalhes Exception");
            }
            finally{
               conn.Close();
            }
        }
        private async void CarregarDadosAssincrono()
        {
            SqlConnection conn = new SqlConnection(@"Data Source=.\sqlexpress;Initial Catalog=Cadastro;Integrated Security=True");
            string sql = @"select Id,Nome from Alunos";
            try
            {
                SqlCommand cmd = new SqlCommand(sql, conn);
                await conn.OpenAsync();

                using (SqlDataReader rdr = await cmd.ExecuteReaderAsync())
                {
                    while (await rdr.ReadAsync())
                    {
                        txtDados.AppendText("\nId: ");
                        txtDados.AppendText(await rdr.GetFieldValueAsync<int>(0) + "\t\t" + await rdr.GetFieldValueAsync<string>(1));
                        txtDados.AppendText("\n");
                    }
                }
            }
            catch (SqlException ex)
            {
                MessageBox.Show(ex.Message + ex.StackTrace, "Detalhes Exception");
            }
            finally
            {
                conn.Close();
            }
        }

        private void btnCarregarAssincrono_Click(object sender, EventArgs e)
        {
            CarregarDadosAssincrono();
        }
    }
}
